; -------------------------------- TTYPE.COM -------------------------------
; MASM 5.1, com file, 286 assembly code, standard portable.
; 
;	TITLE	TTYPE.COM	By Steve Elliott
CSEG	SEGMENT
	ASSUME	CS:CSEG,DS:CSEG,ES:CSEG
	ORG	80h
ARGC	DB	?
	ORG	100h
START:
	JMP	TOGO
GMODE	PROC	; ---- Get video MODE at 0000:0449h mem address
	PUSH	BX
	PUSH	ES
	XOR	BX,BX
	MOV	ES,BX
	MOV	BX,449h
	MOV	AL,ES:[BX]
	POP	ES
	POP	BX	; returns AL = current video mode
	RET
GMODE	ENDP
;
GETINF	PROC ; ---- GETINFILE.INC ----
	PUSH	AX
	PUSH	BX
	PUSH	SI
	PUSH	DI
	MOV	CX,14
	XOR	BX,BX
GIFNL1:
	LODSB
	CMP	AL,13
	JZ	GIFNDO
	CMP	AL,32
	JZ	GIFNDO
	INC	BX
	LOOP	GIFNL1
GIFNDO:
	XOR	AL,AL
	MOV	[SI-1],AL
	MOV	CX,BX
	POP	DI
	POP	DX
	POP	BX
	POP	AX
	RET
GETINF	ENDP ; ---- END GETINFILE.INC ----
;
CLSVGA	PROC ; ---- CLSVGA.INC ----video mode 3
	PUSH	AX
	PUSH	CX
	PUSH	DI
	PUSH	ES
	MOV	DI,0B800h
	MOV	ES,DI
	XOR	DI,DI
	MOV	AL,20h
	MOV	CX,2000
	REPZ	STOSW
	POP	ES
	POP	DI
	POP	CX
	POP	AX
	RET
CLSVGA	ENDP ; ---- END CLSVGA.INC ----
;
GTPM	PROC ; ---- GTPM.INC -- = GoTo xy screen area & Print Message
	PUSH	AX		; to video memory = avoids > file redirection
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	ES
	MOV	BX,0B800h
	MOV	ES,BX
GTML1:	LODSB			; get,
	CMP	AL,0
	JZ	GTMDONE
	XOR	AH,AH
	MOV	CL,160
	MUL	CL
	MOV	BX,AX
	LODSB			; get,
	CMP	AL,0
	JZ	GTMDONE
	XOR	AH,AH
	SHL	AX,1
	ADD	BX,AX
GTML2:	LODSB
	CMP	AL,0
	JZ	GTMDONE
	CMP	AL,13		; CR
	JZ	GTML1
	MOV	ES:[BX],AL
	INC	BX
	INC	BX
	JMP	SHORT GTML2
GTMDONE:
	POP	ES
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	RET
GTPM	ENDP ; ---- END GTPM.INC ----
;
TOEE1:	JMP	EXITERROR
TOGO:	;			; ---- PROGRAM START ----
	MOV	DX,OFFSET MESS2
	CMP	ARGC,0
	JZ	TOEE1		; EXITERROR, no input on command line
	MOV	CX,OFFSET BUFFER
	ADD	CX,100h		; 256 bytes set aside for input address words
	MOV	BUF1ADD,CX
	MOV	AX,SP
	SUB	AX,100h		; 100h stack alloted
	SUB	AX,CX
	MOV	BUF1SIZ,AX	; useable buffer size from progEND 2 stack
;
	MOV	SI,82h
	CALL	GETINF		; get CMNDline infile name 2 ASCIZ = nul0 endin
	MOV	F1ADD,DX
	MOV	DX,OFFSET MESS4	; DX= error message4 address
	JCXZ	TOEE1		; input ASCIZ exiterror
;
	MOV	INPUTCNT,0
	MOV	INPUTOFF,OFFSET INPUTOFF
	MOV	DI,OFFSET INPUTBUF	; word address of input in1, in2 etc
INL1:
	MOV	DX,0		; INword length count zeroed out
	MOV	CX,SI		; save address of start of word
INL2:
	LODSB		; mov byte at DS:SI to AL register, & inc SI
	CMP	AL,13
	JZ	INL3
	CMP	AL,32
	JZ	INL3
	INC	DX
	JMP	SHORT INL2	; back to process INwords
INL3:
	INC	INPUTCNT	; increment count of INwords
	MOV	BL,AL		; save AL
	MOV	AX,CX		; INword address
	STOSW
	MOV	AX,DX		; INword length
	STOSW
	CMP	BL,13
	JNZ	INL1
GOTEOL:
	MOV	DX,F1ADD
	XOR	CL,CL
	MOV	AX,03D20h
	INT	21h		; FOPENR_M open file for reading
	MOV	DX,OFFSET MESS3
	JC	EXITERROR	; file does not exist, EXITERROR
	MOV	F1HAND,AX	; file handle
FILLBUF:
	MOV	BX,F1HAND
	MOV	DX,BUF1ADD
	MOV	CX,BUF1SIZ	; maximum bytes for buffer
	MOV	AH,03Fh
	INT	21h		; FREAD_M read file
	CMP	AX,0		; infile is read if AX=0
	JZ	CLOSEXIT	; the file read is done
	MOV	BUF1CNT,AX	; BUFer byte CouNT & file size
	CALL	DOBUFF
	JMP	SHORT FILLBUF
CLOSEXIT:
	MOV	BX,F1HAND
	MOV	AH,03Eh
	INT	21h		; FCLOSE_M close file
	JMP	SHORT ZZDONE
EXITERROR:
	PUSH	DX
	CALL	GMODE
	MOV	VMODE,AL	; save current video mode
	MOV	AL,3
	XOR	AH,AH
	INT	10h	; set video mode at 3 for error message 2screen
;
	MOV	AH,7
	CALL	CLSVGA
	MOV	SI,OFFSET MESS0
	CALL	GTPM
	POP	SI
	CALL	GTPM
	MOV	SI,OFFSET MESS1
	CALL	GTPM

	MOV	AH,8
	INT	21h		; pause
	MOV	AL,VMODE
	XOR	AH,AH
	INT	10h		; restore original video mode SETvMODE
	MOV	AL,1		; exit error level 1
	JMP	SHORT ELEVEL
ZZDONE:
	MOV	AL,0
ELEVEL:
	MOV	AH,4Ch		; exit with errorlevel # in AL
	INT	21h		; end program
DOBUFF:		; process buffer2 into buff1, overwrites buff2 as it goes
	MOV	SI,BUF1ADD
	MOV	AX,SI
	MOV	CX,BUF1CNT
	ADD	AX,CX
	MOV	LASTBYTE,AX	; got address of last byte in buffer
; xxxcode?
	MOV	BX,AX
	XOR	AL,AL		; put null at end of buffer
	MOV	[BX],AL		; so there isn't an accidental % sign
	MOV	AH,2		; print character function fer int 21h
DBTOP:
	CMP	LASTBYTE,SI
	JA	DBMORE
	RET
DBMORE:
	LODSB
	CMP	AL,37		; %
	JZ	PERCENT
DBWRITE:
	MOV	DL,AL
	INT	21h		; print character to screen/redirect
	JMP	SHORT DBTOP
PERCENT:
	MOV	DL,[SI]
	CMP	DL,37	; %
	JNZ	DBnoDOUBLE	; no double percent sign to print
	LODSB
	JMP	SHORT DBWRITE	; print one % when there are %% two together
DBnoDOUBLE:
	CMP	DL,49		; '1'
	JB	DBWRITE
	CMP	DL,57		; '9'
	JA	DBWRITE
	XOR	DH,DH		; DX is the offset of the offset of INPUTOFF
	SUB	DL,48		; 0
	SHL	DL,1
	SHL	DL,1		; MUL x4
	MOV	BX,INPUTOFF
	ADD	BX,DX
	MOV	DX,WORD PTR [BX]
	INC	BX
	INC	BX
	MOV	CX,WORD PTR [BX]
	MOV	BX,DX
	MOV	AH,2
DBMOVSB:
	MOV	DL,[BX]
	INC	BX
	INT	21h	
	LOOP	DBMOVSB
	INC	SI		; mov SI past %#
	JMP	DBTOP
;
F1HAND	DW	0	; file1 handle
F1ADD	DW	0	; infile name address
BUF1CNT	DW	0	; bytes in buffer1
BUF1SIZ	DW	0	; size of buffer1
BUF1ADD	DW	0	; address of buffer1
BUF2ADD	DW	0	; address of buffer2
BUF2CNT	DW	0	; bytes in buffer2
TEMP1	DB	0	; toggle1
TEMP2	DB	0	; toggle2
VMODE	DB	3	; video mode 3 is default
MESS0	DB	4,5,"An error has Occured.",0
MESS1	DB	7,1,"Syntax = TTYPE INFILE.EXT in1 in2 in3 in4 in5 in6 in7 in8 in9> OUTFILE.EXT",13
	DB	8,5,"Types infile To outfile & every place there is a",13
	DB	9,5,"%1 in INFILE it is replaced with input 1 = in1",13
	DB	10,5,"%2 is replaced with in2, etc, 1-9 max.",13
	DB	11,5,"Command line input has a 255 byte max limit.",13
	DB	12,5,"INFILE.EXT is typed to the screen or redirected to a file with >",13
	DB	13,5,"TTYPE.COM Processes any input file size.",13
	DB	14,5,"Double percent signs %% are printed as one %",13
	DB	15,5,"%%=%, %%5=%5, %%%1=%in1, %%%=%%, %%%word=%%word.  Experiment.",13
	DB	16,5,"TTYPE.COM by Steve Elliott 2-22-2002.",13
	DB	17,5,"Press any key to continue.....",0
MESS2	DB	5,5,"No command line input.",0
MESS3	DB	5,5,"INFILE.EXT does not exist. (note: OUTFILE.EXT may have been created)",0
MESS4	DB	5,5,"Gettin infile name OOPs. (note: OUTFILE.EXT may have been created)",0
EVEN
LASTBYTE DW	0	; last byte read into BUF1
INPUTOFF DW	0
INPUTCNT DW	0	; count the number of input words on command line
INPUTBUF DW	0	; address of input word on command line
BUFFER:			; end of file & start of buffer
CSEG	ENDS
	END	START
